summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJenkins <jenkins@review.openstack.org>2016-10-14 18:22:47 +0000
committerGerrit Code Review <review@openstack.org>2016-10-14 18:22:47 +0000
commit628d9fdc11901dedd76629681e16ace30d1d3796 (patch)
treef3d594c0771091386f11e02e7ee11bff1ea13eb3
parentea2c96bd482f2299aaa180328769c9ef6fd6dd91 (diff)
parent0a3b995d17cb56586138bd2ecb85a932125c1d42 (diff)
downloadpython-barbicanclient-628d9fdc11901dedd76629681e16ace30d1d3796.tar.gz
Merge "Support upper-constraints in tox.ini"
-rwxr-xr-xtools/tox_install.sh53
-rw-r--r--tox.ini2
2 files changed, 54 insertions, 1 deletions
diff --git a/tools/tox_install.sh b/tools/tox_install.sh
new file mode 100755
index 0000000..7203698
--- /dev/null
+++ b/tools/tox_install.sh
@@ -0,0 +1,53 @@
+#!/usr/bin/env bash
+
+# [liujiong] This file is refer to tox_install.sh in neutron-lib.
+# Library constraint file contains this library version pin that is in conflict
+# with installing the library from source. We should replace the version pin in
+# the constraints file before applying it for from-source installation.
+
+ZUUL_CLONER=/usr/zuul-env/bin/zuul-cloner
+BRANCH_NAME=master
+LIB_NAME=python-barbicanclient
+requirements_installed=$(echo "import openstack_requirements" | python 2>/dev/null ; echo $?)
+
+set -e
+
+CONSTRAINTS_FILE=$1
+shift
+
+install_cmd="pip install"
+mydir=$(mktemp -dt "$LIB_NAME-tox_install-XXXXXXX")
+trap "rm -rf $mydir" EXIT
+localfile=$mydir/upper-constraints.txt
+if [[ $CONSTRAINTS_FILE != http* ]]; then
+ CONSTRAINTS_FILE=file://$CONSTRAINTS_FILE
+fi
+curl $CONSTRAINTS_FILE -k -o $localfile
+install_cmd="$install_cmd -c$localfile"
+
+if [ $requirements_installed -eq 0 ]; then
+ echo "Requirements already installed; using existing package"
+elif [ -x "$ZUUL_CLONER" ]; then
+ pushd $mydir
+ $ZUUL_CLONER --cache-dir \
+ /opt/git \
+ --branch $BRANCH_NAME \
+ git://git.openstack.org \
+ openstack/requirements
+ cd openstack/requirements
+ $install_cmd -e .
+ popd
+else
+ if [ -z "$REQUIREMENTS_PIP_LOCATION" ]; then
+ REQUIREMENTS_PIP_LOCATION="git+https://git.openstack.org/openstack/requirements@$BRANCH_NAME#egg=requirements"
+ fi
+ $install_cmd -U -e ${REQUIREMENTS_PIP_LOCATION}
+fi
+
+# This is the main purpose of the script: Allow local installation of
+# the current repo. It is listed in constraints file and thus any
+# install will be constrained and we need to unconstrain it.
+edit-constraints $localfile -- $LIB_NAME "-e file://$PWD#egg=$LIB_NAME"
+
+$install_cmd -U $*
+exit $?
diff --git a/tox.ini b/tox.ini
index ef0cf9c..c3146cd 100644
--- a/tox.ini
+++ b/tox.ini
@@ -5,7 +5,7 @@ skipsdist = True
[testenv]
usedevelop = True
-install_command = pip install -U {opts} {packages}
+install_command = {toxinidir}/tools/tox_install.sh {env:UPPER_CONSTRAINTS_FILE:https://git.openstack.org/cgit/openstack/requirements/plain/upper-constraints.txt} {opts} {packages}
setenv =
VIRTUAL_ENV={envdir}
deps = -r{toxinidir}/requirements.txt